Context menu in EJ2 JavaScript Diagram control

6 Jun 202624 minutes to read

In a graphical user interface (GUI), a context menu is a type of menu that appears when you perform a right-click operation. It offers users a set of actions relevant to the current context. In diagrams, context menus can be customized extensively. The Diagram control provides built-in context menu items while also allowing users to define custom menu items through the contextMenuSettings property. This flexibility enables tailoring menus to specific application needs, including creating nested levels of menu items for more intricate user interactions.To ensure the context menu is rendered correctly with the appropriate styles, make sure to include the necessary CSS references from the Syncfusion® ej2-navigations package. This can be done by adding the following <link> element to the <head> section of your HTML document.

<link href="https://cdn.syncfusion.com/ej2/28.1.33/ej2-navigations/styles/tailwind3.css" rel="stylesheet">

NOTE

If you want to use contextMenu in diagram, you need to inject DiagramContextMenu Module in the diagram.

Default context menu

Diagram provides some default context menu items to ease the execution of some frequently used commands. The show property helps you to enable/disable the context menu. The following code illustrates how to enable the default context menu items.

var nodes = [
    {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      style: {
        fill: '#6BA5D7',
        strokeColor: 'white',
        strokeWidth: 1,
      },
      annotations: [{ content: 'Rectangle1' }],
    },
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 300,
      offsetY: 100,
      style: {
        fill: '#6BA5D7',
        strokeColor: 'white',
        strokeWidth: 1,
      },
      annotations: [{ content: 'Rectangle2' }],
    },
  ];
  var connector = {
    id: 'connector1',
    sourceID: 'node1',
    targetID: 'node2',
    type: 'Straight',
    style: {
      strokeColor: '#6BA5D7',
      fill: '#6BA5D7',
      strokeWidth: 2,
    },
    targetDecorator: {
      style: {
        fill: '#6BA5D7',
        strokeColor: '#6BA5D7',
      },
    },
  };
  var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '350px',
      nodes: nodes,
      connectors: [connector],
      //Enables the context menu
      contextMenuSettings: {
        show: true,
      },
    },
    '#element'
  );
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Custom context menu

Context menus can be customized for individual nodes by defining specific menu items beyond the default options. To add additional context menu items, you need to define and incorporate them into the items property of the context menu.

Each custom item can be defined with specific text and ID using the text and ID properties, respectively. Additionally, you can enhance visual cues by associating icons through the iconCss for enabling the use of font icons. The target property specifies where each menu item should appear, and separators can be included using the separator property to visually group menu items. This flexibility allows for a tailored user interface that meets specific application needs efficiently. Nested menu items are defined within the items property of a parent menu item.

To Display custom menu alone

To display the custom context menu items alone, set the showCustomMenuOnly property to true.

Context menu click

Upon clicking custom menu items, actions are handled using the contextMenuClick event in the diagram. This event allows you to define actions based on which menu item is clicked. For instance, in the example below, the cloning of nodes and the change of fill color for nodes and annotations are efficiently managed and implemented through this event.

var nodes = [
    {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      style: {
        fill: '#6BA5D7',
        strokeColor: 'white',
        strokeWidth: 1,
      },
      annotations: [
        {
          id: 'label1',
          content: 'Rectangle1',
          offset: {
            x: 0.5,
            y: 0.5,
          },
          style: {
            color: 'white',
          },
        },
      ],
    },
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 300,
      offsetY: 100,
      style: {
        fill: '#6BA5D7',
        strokeColor: 'white',
        strokeWidth: 1,
      },
      annotations: [
        {
          id: 'label2',
          content: 'Rectangle2',
          offset: {
            x: 0.5,
            y: 0.5,
          },
          style: {
            color: 'white',
          },
        },
      ],
    },
  ];
  var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '350px',
      nodes: nodes,
      contextMenuSettings: {
        //Enables the context menu
        show: true,
        // Defines the custom context menu items
        items: [
          {
            // Text to be displayed
            text: 'Fill',
            items: [
              { id: 'red', text: 'Red' },
              { id: 'yellow', text: 'Yellow' },
              { id: 'green', text: 'Green' },
              { id: 'blue', text: 'Blue' },
            ],
            //Sets the id for the item
            id: 'fill',
            target: '.e-elementcontent',
            // Sets the css icons for the item
            iconCss: 'e-icons e-paint-bucket',
          },
          {
            text: 'Annotation color',
            id: 'annotationColor',
            items: [
              { id: 'pink', text: 'Pink' },
              { id: 'orange', text: 'Orange' },
              { id: 'violet', text: 'Violet' },
              { id: 'brown', text: 'Brown' },
            ],
            target: '.e-elementcontent',
            iconCss: 'e-icons e-font-color',
          },
          {
            text: 'Clone',
            id: 'clone',
            target: '.e-elementcontent',
            iconCss: 'e-icons e-copy',
          },
        ],
        // Hides the default context menu items
        showCustomMenuOnly: true,
      },
      contextMenuClick: function (args) {
        let selectedNode = diagram.selectedItems.nodes[0];
        if (
          selectedNode &&
          args.item.id !== 'fill' &&
          args.item.id !== 'annotationColor'
        ) {
          if (
            args.item.text === 'Red' ||
            args.item.text === 'Blue' ||
            args.item.text === 'Yellow' ||
            args.item.text === 'Green'
          ) {
            selectedNode.style.fill = args.item.text;
            diagram.dataBind();
          } else if (
            args.item.text === 'Pink' ||
            args.item.text === 'Violet' ||
            args.item.text === 'Orange' ||
            args.item.text === 'Brown'
          ) {
            selectedNode.annotations[0].style.fill = args.item.text;
            diagram.dataBind();
          } else {
            diagram.copy();
            diagram.paste();
          }
        }
      },
    },
    '#element'
  );
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Context menu open

In certain situations, you may want to hide specific menu items based on the selected elements in the diagram. This can be achieved using the contextMenuOpen event. When the context menu is opened via right-click, the contextMenuOpen event is triggered. Within this event, you can create an array of menu items to hide for the selected element and pass it to the hiddenItems property of the contextMenuOpen event argument. The following example demonstrates how to display different custom menu items for nodes, connectors, and the diagram based on the selection.

var connectors = [
  {
    id: 'connector1',
    sourceID: 'node1',
    targetID: 'node2',
  },
];
var nodes = [
  {
    id: 'node1',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'black',
      strokeWidth: 2,
    },
    annotations: [
      {
        id: 'label1',
        content: 'Rectangle1',
        offset: {
          x: 0.5,
          y: 0.5,
        },
        style: {
          color: 'white',
        },
      },
    ],
  },
  {
    id: 'node2',
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'black',
      strokeWidth: 2,
    },
    annotations: [
      {
        id: 'label2',
        content: 'Rectangle2',
        offset: {
          x: 0.5,
          y: 0.5,
        },
        style: {
          color: 'white',
        },
      },
    ],
  },
];
var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '350px',
    nodes: nodes,
    connectors: connectors,
    contextMenuSettings: {
      //Enables the context menu
      show: true,
      items: [
        {
          text: 'Change fill',
          id: 'applyFill',
          target: '.e-diagramcontent',
          iconCss: 'e-icons e-paint-bucket',
        },
        {
          text: 'Change stroke',
          id: 'applyStroke',
          target: '.e-diagramcontent',
          iconCss: 'e-icons e-edit',
        },
        {
          text: 'Select All',
          id: 'selectAll',
          target: '.e-diagramcontent',
        },
      ],
      // Hides the default context menu items
      showCustomMenuOnly: true,
    },
    contextMenuOpen: function (args) {
      let hiddenItems = [];
      let selectedNode = diagram.selectedItems.nodes[0];
      let selectedConnector = diagram.selectedItems.connectors[0];
      if (selectedNode || selectedConnector) {
        hiddenItems.push('selectAll');
      } else {
        hiddenItems = ['applyFill', 'applyStroke'];
      }
      args.hiddenItems = hiddenItems;
    },
    contextMenuClick: function (args) {
      let selectedNode = diagram.selectedItems.nodes[0];
      let selectedConnector = diagram.selectedItems.connectors[0];
      if (selectedNode || selectedConnector) {
        if (selectedNode) {
          if (args.item.id === 'applyFill') {
            selectedNode.style.fill =
              selectedNode.style.fill === '#6BA5D7' ? 'green' : '#6BA5D7';
          } else if (args.item.id === 'applyStroke') {
            selectedNode.style.strokeColor =
              selectedNode.style.strokeColor === 'black' ? 'yellow' : 'black';
          }
        }
        if (selectedConnector) {
          if (args.item.id === 'applyFill') {
            selectedConnector.targetDecorator.style.fill =
              selectedConnector.targetDecorator.style.fill === 'yellow'
                ? 'black'
                : 'yellow';
          }
          selectedConnector.style.strokeColor =
            selectedConnector.style.strokeColor === 'black'
              ? 'yellow'
              : 'black';
        }
      } else {
        diagram.selectAll();
      }
    },
  },
  '#element'
);
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Context menu with Url

url property of the menu item is used to set the url of any website which will be opened upon clicking on them. The following example shows the context menu with url for three websites.

var nodes = [
  {
    id: 'node1', width: 100, height: 100, offsetX: 100, offsetY: 100,
    style: { fill: '#6BA5D7', strokeColor: 'white', strokeWidth: 1 },
    annotations: [{
      id: 'label1', content: 'Rectangle1',
      offset: { x: 0.5, y: 0.5 },
      style: { color: 'white' }
    }]
  },
  {
    id: 'node2', width: 100, height: 100, offsetX: 300, offsetY: 100,
    style: { fill: '#6BA5D7', strokeColor: 'white', strokeWidth: 1 },
    annotations: [{
      id: 'label2', content: 'Rectangle2', offset: { x: 0.5, y: 0.5 },
      style: { color: 'white' }
    }]
  }
];

var menuItems = [
  { text: 'Google.com', id: 'google', url: 'https://www.google.co.in/' },
  { text: 'w3schools.com', id: 'W3Schools', url: 'https://www.w3schools.com/' },
  { text: 'stackoverflow.com', id: 'stackoverflow', url: 'https://stackoverflow.com/' }
];

new ej.diagrams.Diagram({
  width: '100%',
  height: '350px',
  nodes,
  contextMenuSettings: {
    show: true,
    items: menuItems.map(item => ({ ...item, target: '.e-diagramcontent' })),
    showCustomMenuOnly: true
  }
}, '#element');

Template Support for Context menu

Diagram provides template support for the context menu. The template for the context menu items can be customized before rendering by using the contextMenuBeforeItemRender event, which triggers while rendering each menu item.

In the following example, menu items are rendered with shortcut key codes for specific actions in the context menu using a template. The key codes for cut, copy, and paste actions are displayed at the right corner of the menu items by adding a span element in the contextMenuBeforeItemRender event.

var nodes = [
    {
      id: 'node1',
      width: 100,
      height: 100,
      offsetX: 100,
      offsetY: 100,
      style: {
        fill: '#6BA5D7',
        strokeColor: 'white',
        strokeWidth: 1,
      },
      annotations: [
        {
          id: 'label1',
          content: 'Rectangle1',
          offset: {
            x: 0.5,
            y: 0.5,
          },
          style: {
            color: 'white',
          },
        },
      ],
    },
    {
      id: 'node2',
      width: 100,
      height: 100,
      offsetX: 300,
      offsetY: 100,
      style: {
        fill: '#6BA5D7',
        strokeColor: 'white',
        strokeWidth: 1,
      },
      annotations: [
        {
          id: 'label2',
          content: 'Rectangle2',
          offset: {
            x: 0.5,
            y: 0.5,
          },
          style: {
            color: 'white',
          },
        },
      ],
    },
  ];
  var diagram = new ej.diagrams.Diagram(
    {
      width: '100%',
      height: '350px',
      nodes: nodes,
      contextMenuSettings: {
        //Enables the context menu
        show: true,
        items: [
          {
            text: 'Cut',
            id: 'Cut',
            target: '.e-diagramcontent',
            iconCss: 'e-cut e-icons',
          },
          {
            text: 'Copy',
            id: 'Copy',
            target: '.e-diagramcontent',
            iconCss: 'e-icons e-copy',
          },
          {
            text: 'Paste',
            id: 'Paste',
            target: '.e-diagramcontent',
            iconCss: 'e-icons e-paste',
          },
        ],
        // Hides the default context menu items
        showCustomMenuOnly: true,
      },
      contextMenuBeforeItemRender: (args) => {
        // To render template in li.
        let shortCutSpan = ej.base.createElement('span');
        let text = args.item.text;
        let shortCutText =
          text === 'Cut' ? 'Ctrl + X' : text === 'Copy' ? 'Ctrl + C' : 'Ctrl + V';
        shortCutSpan.textContent = shortCutText;
        //Added CSS styles for the class shortcut to customize its position and appearance
        shortCutSpan.setAttribute('class', 'shortcut');
        args.element.appendChild(shortCutSpan);
      },
      contextMenuClick: function (args) {
        let selectedNode = diagram.selectedItems.nodes[0];
        if (selectedNode) {
          if (args.item.text === 'Cut') {
            diagram.cut();
          } else if (args.item.text === 'Copy') {
            diagram.copy();
          }
        }
        if (args.item.text === 'Paste') {
          diagram.paste();
        }
      },
    },
    '#element'
  );
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>
<style>
    .shortcut {
       float: right;
       color: #999999;
       font-size: 12px;
       margin-left: 20px;
     }
</style>
<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Context menu events

Event Description
contextMenuBeforeItemRender Triggers while initializing each menu item.
contextMenuOpen Triggers upon right-click before opening the context menu.
contextMenuClick Triggers when a menu item is clicked.

The following example shows how to get these events.

var nodes = [
  {
    id: 'node1',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
      strokeWidth: 1,
    },
    annotations: [
      {
        id: 'label1',
        content: 'Rectangle1',
        offset: {
          x: 0.5,
          y: 0.5,
        },
        style: {
          color: 'white',
        },
      },
    ],
  },
  {
    id: 'node2',
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
      strokeWidth: 1,
    },
    annotations: [
      {
        id: 'label2',
        content: 'Rectangle2',
        offset: {
          x: 0.5,
          y: 0.5,
        },
        style: {
          color: 'white',
        },
      },
    ],
  },
];
var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '350px',
    nodes: nodes,
    contextMenuSettings: {
      //Enables the context menu
      show: true,
      items: [
        {
          text: 'menu item 1',
          id: 'item1',
        },
        {
          text: 'menu item 2',
          id: 'item2',
        },
      ],
      // Hides the default context menu items
      showCustomMenuOnly: true,
    },
    contextMenuBeforeItemRender: (args) => {
      //Triggers for each menu item
      console.log('context menu before item render');
    },
    contextMenuOpen: function (args) {
      //Triggers when the menu is openned
      console.log('context menu openned');
    },
    contextMenuClick: function (args) {
      //Triggers when the item is clicked
      console.log('context menu clicked');
    },
  },
  '#element'
);
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

See Also

Context Menu in Angular Diagram Component

4 Jun 202624 minutes to read

In graphical user interfaces, a context menu appears when you perform a right-click operation, offering users a set of actions relevant to the current context. The Angular Diagram component provides extensive context menu customization capabilities through the contextMenuSettings property.

The Diagram control includes built-in context menu items and allows you to define custom menu items. This flexibility enables you to tailor menus to specific application needs, including creating nested levels of menu items for complex user interactions.

Prerequisites

To ensure the context menu renders correctly, include the necessary CSS references from the Syncfusion® ej2-navigations package by adding the following line to your src/styles.css file:

@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";

Default Context Menu

The Diagram component provides default context menu items for frequently used commands. Use the show property to enable or disable the context menu.

The following code demonstrates how to enable the default context menu items:

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule, DiagramContextMenuService, DiagramComponent, ShapeStyleModel } from '@syncfusion/ej2-angular-diagrams';
import { ContextMenuSettingsModel } from '@syncfusion/ej2-diagrams';

@Component({
imports: [
         DiagramModule
    ],

providers: [DiagramContextMenuService],
standalone: true,
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px"[contextMenuSettings]="contextMenuSettings">
        <e-nodes>
            <e-node id='node1' [offsetX]=100 [offsetY]=100 [width]=100 [height]=100>
                <e-node-annotations>
                    <e-node-annotation id="label1" content="Rectangle1">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node2' [offsetX]=300 [offsetY]=100 [width]=100 [height]=100>
                <e-node-annotations>
                    <e-node-annotation id="label1" content="Rectangle2">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
        </e-nodes>
        <e-connectors>
            <e-connector id='connector1' type='Straight' sourceID='node1' targetID='node2'>
            </e-connector>
        </e-connectors>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public contextMenuSettings?: ContextMenuSettingsModel
    ngOnInit(): void {
        //Enables the context menu
        this.contextMenuSettings = {
            show: true,
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Customize Context Menu

You can customize context menus for individual nodes by defining specific menu items beyond the default options. To add custom context menu items, define and incorporate them into the items property of the context menu.

Each custom item can be configured with the following properties:

  • text: Display text for the menu item
  • ID: Unique identifier for the menu item
  • iconCss: CSS class for font icons
  • target: Specifies where the menu item should appear
  • separator: Adds visual separation between menu items

For nested menu structures, define child items within the items property of a parent menu item.

Display Custom Menu Only

To display only custom context menu items, set the showCustomMenuOnly property to true.

Context Menu Click

Handle custom menu item actions using the contextMenuClick event. This event triggers when a menu item is clicked and allows you to define specific actions based on the selected item.

The following example demonstrates context menu click handling for node cloning and color changes:

import { DiagramModule, DiagramContextMenuService, DiagramComponent } from '@syncfusion/ej2-angular-diagrams'
import {Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { ContextMenuSettingsModel } from '@syncfusion/ej2-diagrams';
import { MenuEventArgs } from '@syncfusion/ej2-navigations';

@Component({
imports: [
         DiagramModule
    ],

providers: [DiagramContextMenuService],
standalone: true,
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [contextMenuSettings]="contextMenuSettings" (contextMenuClick)="contextMenuClick($event)">
        <e-nodes>
            <e-node id='node1' [offsetX]=100 [offsetY]=100 [width]=100 [height]=100 >
                <e-node-annotations>
                    <e-node-annotation id="label1" content="Rectangle1" >
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node2' [offsetX]=350 [offsetY]=150 [width]=100 [height]=100>
                <e-node-annotations>
                    <e-node-annotation id="label1" content="Rectangle2">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public contextMenuSettings?: ContextMenuSettingsModel;

    ngOnInit(): void {

        //Enables the context menu
        this.contextMenuSettings = {
            //Enables the context menu
            show: true,
            // Defines the custom context menu items
            items: [{
                // Text to be displayed
                text: 'Fill',
                items: [
                  { id: 'red', text: 'Red' },
                  { id: 'yellow', text: 'Yellow' },
                  { id: 'green', text: 'Green' },
                  { id: 'blue', text: 'Blue' },
                ],
                //Sets the id for the item
                id: 'fill',
                target: '.e-elementcontent',
                // Sets the css icons for the item
                iconCss: 'e-icons e-paint-bucket',
              },
              {
                text: 'Annotation color',
                id: 'annotationColor',
                items: [
                  { id: 'pink', text: 'Pink' },
                  { id: 'orange', text: 'Orange' },
                  { id: 'violet', text: 'Violet' },
                  { id: 'brown', text: 'Brown' },
                ],
                target: '.e-elementcontent',
                iconCss: 'e-icons e-font-color',
              },
              {
                text: 'Clone',
                id: 'clone',
                target: '.e-elementcontent',
                iconCss: 'e-icons e-copy',
              },
            ],
            // Hides the default context menu items
          showCustomMenuOnly: true,
        }
    }

    public contextMenuClick(args: MenuEventArgs): void {
        let selectedNode = (this.diagram as any).selectedItems.nodes[0];
        if (selectedNode && args.item.id !== 'fill' &&  args.item.id !== 'annotationColor') {
            if (
              args.item.text === 'Red' ||
              args.item.text === 'Blue' ||
              args.item.text === 'Yellow' ||
              args.item.text === 'Green'
            ) {
              selectedNode.style.fill = args.item.text;
              (this.diagram as any).dataBind();
            } else if (
              args.item.text === 'Pink' ||
              args.item.text === 'Violet' ||
              args.item.text === 'Orange' ||
              args.item.text === 'Brown'
            ) {
              selectedNode.annotations[0].style.fill = args.item.text;
              (this.diagram as any).dataBind();
            } else {
                (this.diagram as any).copy();
              (this.diagram as any).paste();
            }
        }

    }
    
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Context Menu Open

You can conditionally hide specific menu items based on selected elements using the contextMenuOpen event. When the context menu opens via right-click, this event triggers and allows you to create an array of menu items to hide for the selected element. Pass this array to the hiddenItems property of the contextMenuOpen event argument.

The following example shows how to display different custom menu items for nodes, connectors, and the diagram based on selection:

import {Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule, DiagramContextMenuService, DiagramComponent} from '@syncfusion/ej2-angular-diagrams'
import { MenuEventArgs } from '@syncfusion/ej2-navigations';
import { ContextMenuSettingsModel,DiagramBeforeMenuOpenEventArgs} from '@syncfusion/ej2-diagrams';

@Component({
imports: [
         DiagramModule
    ],

providers: [DiagramContextMenuService],
standalone: true,
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [contextMenuSettings]="contextMenuSettings" (contextMenuOpen)="contextMenuOpen($event)" (contextMenuClick)="contextMenuClick($event)">
        <e-nodes>
            <e-node id='node1' [offsetX]=100 [offsetY]=100 [width]=100 [height]=100 >
                <e-node-annotations>
                    <e-node-annotation id="label1" content="Rectangle1">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node2' [offsetX]=300 [offsetY]=100 [width]=100 [height]=100 >
                <e-node-annotations>
                    <e-node-annotation id="label1" content="Rectangle2">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
        </e-nodes>
        <e-connectors>
            <e-connector id='connector1' type='Straight' sourceID='node1' targetID='node2'>
            </e-connector>
        </e-connectors>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public contextMenuSettings?: ContextMenuSettingsModel;

    ngOnInit(): void {
        //Enables the context menu
        this.contextMenuSettings = {
            show: true,
            items: [
                {
                  text: 'Change fill',
                  id: 'applyFill',
                  target: '.e-diagramcontent',
                  iconCss: 'e-icons e-paint-bucket',
                },
                {
                  text: 'Change stroke',
                  id: 'applyStroke',
                  target: '.e-diagramcontent',
                  iconCss: 'e-icons e-edit',
                },
                {
                  text: 'Select All',
                  id: 'selectAll',
                  target: '.e-diagramcontent',
                },
            ],
            // Hides the default context menu items
            showCustomMenuOnly: true,
        }
    }
    public contextMenuOpen(args: DiagramBeforeMenuOpenEventArgs): void {
        let hiddenItems = [];
        let selectedNode = (this.diagram as any).selectedItems.nodes[0];
        let selectedConnector = (this.diagram as any).selectedItems.connectors[0];
        if (selectedNode || selectedConnector) {
            hiddenItems.push('selectAll');
        } else {
        hiddenItems = ['applyFill', 'applyStroke'];
        }
        args.hiddenItems = hiddenItems
    }
      
    public contextMenuClick(args: MenuEventArgs): void {
        let selectedNode = (this.diagram as any).selectedItems.nodes[0];
        let selectedConnector = (this.diagram as any).selectedItems.connectors[0];
        if (selectedNode || selectedConnector) {
            if (selectedNode) {
                if (args.item.id === 'applyFill') {
                  selectedNode.style.fill =
                    selectedNode.style.fill === '#6BA5D7' ? 'green' : '#6BA5D7';
                } else if (args.item.id === 'applyStroke') {
                  selectedNode.style.strokeColor =
                    selectedNode.style.strokeColor === 'black' ? 'yellow' : 'black';
                }
            }
            if (selectedConnector) {
                if (args.item.id === 'applyFill') {
                  selectedConnector.targetDecorator.style.fill =
                    selectedConnector.targetDecorator.style.fill === 'yellow'? 'black': 'yellow';
                }
                selectedConnector.style.strokeColor =
                  selectedConnector.style.strokeColor === 'black' ? 'yellow': 'black';
                } 
        } else {
            (this.diagram as any).selectAll();
        }
          
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Context Menu with URL

Use the url property of menu items to set website URLs that open when clicked.

The following example demonstrates context menu items with URLs for three websites:

import {Component, ViewEncapsulation, OnInit, ViewChild} from '@angular/core'
import { DiagramModule, DiagramContextMenuService,DiagramComponent } from '@syncfusion/ej2-angular-diagrams'
import { ContextMenuSettingsModel } from '@syncfusion/ej2-diagrams';

@Component({
imports: [
         DiagramModule
    ],

providers: [DiagramContextMenuService],
standalone: true,
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px"  [contextMenuSettings]="contextMenuSettings">
        <e-nodes>
            <e-node id='node1' [offsetX]=100 [offsetY]=100 [width]=100 [height]=100>
                <e-node-annotations>
                    <e-node-annotation id="label1" content="Rectangle1">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node2' [offsetX]=300 [offsetY]=100 [width]=100 [height]=100>
                <e-node-annotations>
                    <e-node-annotation id="label1" content="Rectangle2" >
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public contextMenuSettings?: ContextMenuSettingsModel;

    ngOnInit(): void {
        //Enables the context menu
        this.contextMenuSettings = {
          //Enables the context menu
          show: true,
          items: [
            {
              text: 'Google.com',
              id: 'google',
              target: '.e-diagramcontent',
              url: 'https://www.google.co.in/',
            },
            {
              text: 'w3schools.com',
              id: 'W3Schools',
              target: '.e-diagramcontent',
              url: 'https://www.w3schools.com/',
            },
            {
              text: 'stackoverflow.com',
              id: 'stackoverflow',
              target: '.e-diagramcontent',
              url: 'https://stackoverflow.com/',
            }],
          // Hides the default context menu items
          showCustomMenuOnly: true,
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Template Support for Context Menu

The Diagram component provides template support for context menu customization. Customize menu item templates before rendering using the contextMenuBeforeItemRender event, which triggers while rendering each menu item.

The following example renders menu items with shortcut key codes for specific actions. Key codes for cut, copy, and paste actions display in the right corner of menu items by adding a span element in the contextMenuBeforeItemRender event:

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { createElement } from "@syncfusion/ej2-base";
import { DiagramModule, DiagramContextMenuService ,DiagramComponent } from '@syncfusion/ej2-angular-diagrams';
import { ContextMenuSettingsModel } from '@syncfusion/ej2-diagrams';
import { MenuEventArgs } from '@syncfusion/ej2-navigations';

@Component({
imports: [
         DiagramModule
    ],

providers: [DiagramContextMenuService],
standalone: true,
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [contextMenuSettings]="contextMenuSettings" (contextMenuBeforeItemRender)='contextMenuBeforeItemRender($event)'>
        <e-nodes>
            <e-node id='node1' [offsetX]=100 [offsetY]=100 [width]=100 [height]=100>
                <e-node-annotations>
                    <e-node-annotation id="label1" content="Rectangle1">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node2' [offsetX]=300 [offsetY]=100 [width]=100 [height]=100 >
                <e-node-annotations>
                    <e-node-annotation id="label1" content="Rectangle2">
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public contextMenuSettings?: ContextMenuSettingsModel;

    ngOnInit(): void {
        //Enables the context menu
        this.contextMenuSettings = {
          //Enables the context menu
          show: true,
          items: [{
            text: 'Cut  ', id: 'cut', target: '.e-diagramcontent',
            iconCss: 'e-cut e-icons'
          },
          {
            text: 'Copy  ', id: 'copy', target: '.e-diagramcontent',
            iconCss: 'e-icons e-copy'
          },
          {
            text: 'Paste', id:'paste', target: '.e-diagramcontent',
            iconCss: 'e-icons e-paste'
          }],
          //hides the default context menu items
          showCustomMenuOnly: true,
        }
    }
    public contextMenuBeforeItemRender(args: MenuEventArgs) {
        // To render template in li.
        let shortCutSpan: HTMLElement = createElement('span');
        let text: string = args.item.text as string;
        let shortCutText: string = text === 'Cut  ' ? 'Ctrl + X' : (text === 'Copy  ' ?
        'Ctrl + C' : 'Ctrl + V');
        shortCutSpan.textContent = shortCutText;
        args.element.appendChild(shortCutSpan);
        shortCutSpan.setAttribute('class', 'shortcut');
         
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Context Menu Events

The following events are available for context menu interactions:

Event Description
contextMenuBeforeItemRender Triggers while initializing each menu item.
contextMenuOpen Triggers upon right-click before opening the context menu.
contextMenuClick Triggers when a menu item is clicked.

The following example demonstrates how to handle these events:

import { Component, ViewEncapsulation, OnInit, ViewChild } from '@angular/core';
import { DiagramModule, DiagramContextMenuService,DiagramComponent } from '@syncfusion/ej2-angular-diagrams';
import { ContextMenuSettingsModel,DiagramBeforeMenuOpenEventArgs, } from '@syncfusion/ej2-diagrams';
import { MenuEventArgs } from '@syncfusion/ej2-navigations';

@Component({
imports: [
         DiagramModule
    ],

providers: [DiagramContextMenuService],
standalone: true,
    selector: "app-container",
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px"  [contextMenuSettings]="contextMenuSettings" (contextMenuBeforeItemRender)="contextMenuBeforeItemRender($event)" (contextMenuOpen)="contextMenuOpen($event)" (contextMenuClick)="contextMenuClick($event)">
        <e-nodes>
            <e-node id='node1' [offsetX]=100 [offsetY]=100>
                <e-node-annotations>
                    <e-node-annotation id="label1" content="Rectangle1" [width]=100 [height]=100>
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
            <e-node id='node2' [offsetX]=300 [offsetY]=100 [width]=100 [height]=100>
                <e-node-annotations>
                    <e-node-annotation id="label1" content="Rectangle2" >
                    </e-node-annotation>
                </e-node-annotations>
            </e-node>
        </e-nodes>
        <e-connectors>
            <e-connector id='connector' type='Orthogonal' sourceID='node1' targetID='node2'>
            </e-connector>
        </e-connectors>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public contextMenuSettings?: ContextMenuSettingsModel;
    ngOnInit(): void {
        //Enables the context menu
        this.contextMenuSettings = {
            //Enables the context menu
            show: true,
            items: [
                {
                    text: 'menu item 1',
                    id: 'item1',
                },
                {
                    text: 'menu item 2',
                    id: 'item2'
                },
            ],
            // Hides the default context menu items
            showCustomMenuOnly: true,
        } as ContextMenuSettingsModel;
    }

    public contextMenuBeforeItemRender(args: MenuEventArgs): void {
        //Triggers for each menu item
        console.log('context menu before item render');
    }
    public contextMenuOpen(args: DiagramBeforeMenuOpenEventArgs): void {
        //Triggers when the menu is openned
        console.log('context menu openned');
    }
      
    public contextMenuClick(args: MenuEventArgs): void {
        //Triggers when the item is clicked
        console.log('context menu clicked');
    }
    
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

See Also

Context Menu in React Diagram Component

21 Jul 202624 minutes to read

In graphical user interfaces, a context menu appears when you perform a right-click operation, offering users a set of actions relevant to the current context. The React Diagram component provides extensive context menu customization capabilities through the contextMenuSettings property.

The Diagram control includes built-in context menu items and allows you to define custom menu items. This flexibility enables you to tailor menus to specific application needs, including creating nested levels of menu items for complex user interactions.

Prerequisites

To ensure the context menu renders correctly, include the necessary CSS references from the Syncfusion® ej2-navigations package by adding the following line to your src/styles.css file:

@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";

NOTE

If you want to use contextMenu in diagram, you need to inject DiagramContextMenu Module in the diagram.

Default Context Menu

The Diagram component provides default context menu items for frequently used commands. Use the show property to enable or disable the context menu.

The following code demonstrates how to enable the default context menu items:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, DiagramContextMenu, Inject } from "@syncfusion/ej2-react-diagrams";

let diagramInstance;
let connector = [{
        id: 'connector1',
        sourceID: 'node1',
        targetID: 'node2',
        type: 'Straight',
       
}];

let node = [{
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{content: 'Rectangle1'}],
    }, {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{content: 'Rectangle2'}],
    }
];

//Initializes the Diagram component
function App() {
    return (<DiagramComponent id="diagram_contextmenu" ref={(diagram) => (diagramInstance = diagram)} width={'650px'} height={'350px'} nodes={node} connectors={connector} contextMenuSettings=>
      <Inject services={[DiagramContextMenu]}/>
    </DiagramComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent,NodeModel,ConnectorModel, DiagramContextMenu, Inject } from "@syncfusion/ej2-react-diagrams";

let diagramInstance: DiagramComponent;
let connector: ConnectorModel[] = [{
        id: 'connector1',
        sourceID: 'node1',
        targetID: 'node2',
        type: 'Straight',
       
}];

let node: NodeModel[] = [{
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{content: 'Rectangle1'}],
    }, {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{content: 'Rectangle2'}],
    }
];

//Initializes the Diagram component
function App() {
        return (<DiagramComponent id="diagram_contextmenu" ref={(diagram) => (diagramInstance = diagram)} width={'650px'} height={'350px'} nodes={node} connectors={connector} contextMenuSettings=>
        <Inject services={[DiagramContextMenu]}/>
        </DiagramComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Customize Context Menu

You can customize context menus for individual nodes by defining specific menu items beyond the default options. To add custom context menu items, define and incorporate them into the items property of the context menu.

Each custom item can be defined with specific text and ID using thetext and ID properties, respectively. Additionally, you can enhance visual cues by associating icons through the iconCss for enabling the use of font icons. The target property specifies where each menu item should appear, and separators can be included using the separator property to visually group menu items. This flexibility allows for a tailored user interface that meets specific application needs efficiently. Nested menu items are defined within the items property of a parent menu item.

Display Custom Menu Only

To display only custom context menu items, set the showCustomMenuOnly property to true.

Context Menu Click

Handle custom menu item actions using the contextMenuClick event. This event triggers when a menu item is clicked and allows you to define specific actions based on the selected item.

The following example demonstrates context menu click handling for node cloning and color changes:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, DiagramContextMenu, Inject } from "@syncfusion/ej2-react-diagrams";

let diagramInstance;

let node = [{
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{id: 'label1',content: 'Rectangle1'}],
    }, {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{id: 'label2',content: 'Rectangle2'}],
    }
];
const contextMenuSettings = {
    //Enables the context menu
    show: true,
    items: [
        {
            // Text to be displayed
            text: 'Fill',
            items: [
            { id: 'red', text: 'Red' },
            { id: 'yellow', text: 'Yellow' },
            { id: 'green', text: 'Green' },
            { id: 'blue', text: 'Blue' },
            ],
            //Sets the id for the item
            id: 'fill',
            target: '.e-elementcontent',
            // Sets the css icons for the item
            iconCss: 'e-icons e-paint-bucket',
        },
        {
            text: 'Annotation color',
            id: 'annotationColor',
            items: [
            { id: 'pink', text: 'Pink' },
            { id: 'orange', text: 'Orange' },
            { id: 'violet', text: 'Violet' },
            { id: 'brown', text: 'Brown' },
            ],
            target: '.e-elementcontent',
            iconCss: 'e-icons e-font-color',
        },
        {
            text: 'Clone',
            id: 'clone',
            target: '.e-elementcontent',
            iconCss: 'e-icons e-copy',
        },
        ],
    // Hides the default context menu items
    showCustomMenuOnly: true,
};
//Initializes the Diagram component
function App() {
    return (<DiagramComponent id="diagram_contextmenu" ref={(diagram) => (diagramInstance = diagram)} width={'650px'} height={'350px'} nodes={node}  
        contextMenuSettings={contextMenuSettings}  

        contextMenuClick={(args) => {
            let selectedNode = diagramInstance.selectedItems.nodes[0];
            if (selectedNode && args.item.id !== 'fill' && args.item.id !== 'annotationColor') {
                if (
                    args.item.text === 'Red' ||
                    args.item.text === 'Blue' ||
                    args.item.text === 'Yellow' ||
                    args.item.text === 'Green'
                ) {
                    selectedNode.style.fill = args.item.text;
                    diagramInstance.dataBind();
                } else if (
                    args.item.text === 'Pink' ||
                    args.item.text === 'Violet' ||
                    args.item.text === 'Orange' ||
                    args.item.text === 'Brown'
                ) {
                    selectedNode.annotations[0].style.fill = args.item.text;
                    diagramInstance.dataBind();
                } else {
                    diagramInstance.copy();
                    diagramInstance.paste();
                }
            }
        }}>
    <Inject services={[DiagramContextMenu]}/>
    </DiagramComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, DiagramContextMenu, Inject, NodeModel } from "@syncfusion/ej2-react-diagrams";
import { MenuEventArgs } from '@syncfusion/ej2-navigations';

let diagramInstance: DiagramComponent ;

let node: NodeModel[] = [{
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{id: 'label1',content: 'Rectangle1'}],
    }, {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{id: 'label2',content: 'Rectangle2'}],
    }
];

const contextMenuSettings = {
    //Enables the context menu
    show: true,
    items: [
        {
            // Text to be displayed
            text: 'Fill',
            items: [
            { id: 'red', text: 'Red' },
            { id: 'yellow', text: 'Yellow' },
            { id: 'green', text: 'Green' },
            { id: 'blue', text: 'Blue' },
            ],
            //Sets the id for the item
            id: 'fill',
            target: '.e-elementcontent',
            // Sets the css icons for the item
            iconCss: 'e-icons e-paint-bucket',
        },
        {
            text: 'Annotation color',
            id: 'annotationColor',
            items: [
            { id: 'pink', text: 'Pink' },
            { id: 'orange', text: 'Orange' },
            { id: 'violet', text: 'Violet' },
            { id: 'brown', text: 'Brown' },
            ],
            target: '.e-elementcontent',
            iconCss: 'e-icons e-font-color',
        },
        {
            text: 'Clone',
            id: 'clone',
            target: '.e-elementcontent',
            iconCss: 'e-icons e-copy',
        },
        ],
    // Hides the default context menu items
    showCustomMenuOnly: true,
};

//Initializes the Diagram component
function App() {
    return (<DiagramComponent id="diagram_contextmenu" ref={(diagram) => (diagramInstance = diagram)} width={'650px'} height={'350px'} nodes={node}  
        contextMenuSettings={contextMenuSettings}  

        contextMenuClick={(args: MenuEventArgs) => {
            let selectedNode = diagramInstance.selectedItems.nodes[0];
            if (selectedNode && args.item.id !== 'fill' && args.item.id !== 'annotationColor') {
                if (
                    args.item.text === 'Red' ||
                    args.item.text === 'Blue' ||
                    args.item.text === 'Yellow' ||
                    args.item.text === 'Green'
                ) {
                    selectedNode.style.fill = args.item.text;
                    diagramInstance.dataBind();
                } else if (
                    args.item.text === 'Pink' ||
                    args.item.text === 'Violet' ||
                    args.item.text === 'Orange' ||
                    args.item.text === 'Brown'
                ) {
                    selectedNode.annotations[0].style.fill = args.item.text;
                    diagramInstance.dataBind();
                } else {
                    diagramInstance.copy();
                    diagramInstance.paste();
                }
            }
        }}>
    <Inject services={[DiagramContextMenu]}/>
    </DiagramComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Context Menu Open

In certain situations, you may want to hide specific menu items based on the selected elements in the diagram. This can be achieved using the contextMenuOpen event. When the context menu opens via right-click, this event triggers and allows you to create an array of menu items to hide for the selected element. Pass this array to thehiddenItems property of the contextMenuOpen event argument.

The following example shows how to display different custom menu items for nodes, connectors, and the diagram based on selection:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, DiagramContextMenu, Inject } from "@syncfusion/ej2-react-diagrams";

let diagramInstance;

let node = [{
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{id: 'label1',content: 'Rectangle1'}],
    }, {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{id: 'label2',content: 'Rectangle2'}],
    }
];

let connectors = [
    {
      id: 'connector1',
      sourceID: 'node1',
      targetID: 'node2',
    },
  ];

const contextMenuSettings = {
    //Enables the context menu
    show: true,
    items: [
        {
          text: 'Change fill',
          id: 'applyFill',
          target: '.e-diagramcontent',
          iconCss: 'e-icons e-paint-bucket',
        },
        {
          text: 'Change stroke',
          id: 'applyStroke',
          target: '.e-diagramcontent',
          iconCss: 'e-icons e-edit',
        },
        {
          text: 'Select All',
          id: 'selectAll',
          target: '.e-diagramcontent',
        },
      ],
    // Hides the default context menu items
    showCustomMenuOnly: true,
};

//Initializes the Diagram component
function App() {
    return (<DiagramComponent id="diagram_contextmenu" ref={(diagram) => (diagramInstance = diagram)} width={'650px'} height={'350px'} nodes={node} connectors={connectors}
        contextMenuSettings={contextMenuSettings}  

        contextMenuOpen= {(args) =>{

            let hiddenItems = [];
            let selectedNode = diagramInstance.selectedItems.nodes[0];
            let selectedConnector = diagramInstance.selectedItems.connectors[0];
            if (selectedNode || selectedConnector) {
                hiddenItems.push('selectAll');
            } else {
                hiddenItems = ['applyFill', 'applyStroke'];
            }
            args.hiddenItems = hiddenItems;

        }}

        contextMenuClick= {(args) => {
            let selectedNode = diagramInstance.selectedItems.nodes[0];
            let selectedConnector = diagramInstance.selectedItems.connectors[0];
            if (selectedNode || selectedConnector) {
              if (selectedNode) {
                if (args.item.id === 'applyFill') {
                  selectedNode.style.fill =
                    selectedNode.style.fill === '#6BA5D7' ? 'green' : '#6BA5D7';
                } else if (args.item.id === 'applyStroke') {
                  selectedNode.style.strokeColor =
                    selectedNode.style.strokeColor === 'black' ? 'yellow' : 'black';
                }
              }
              if (selectedConnector) {
                if (args.item.id === 'applyFill') {
                  selectedConnector.targetDecorator.style.fill =
                    selectedConnector.targetDecorator.style.fill === 'yellow'
                      ? 'black'
                      : 'yellow';
                }
                selectedConnector.style.strokeColor =
                  selectedConnector.style.strokeColor === 'black'
                    ? 'yellow'
                    : 'black';
              }
            } else {
                diagramInstance.selectAll();
            }
        }}>
    <Inject services={[DiagramContextMenu]}/>
    </DiagramComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, DiagramContextMenu, Inject, NodeModel, ConnectorModel, DiagramBeforeMenuOpenEventArgs } from "@syncfusion/ej2-react-diagrams";
import { MenuEventArgs } from '@syncfusion/ej2-navigations';

let diagramInstance: DiagramComponent;

let node: NodeModel[] = [{
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{id: 'label1',content: 'Rectangle1'}],
    }, {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{id: 'label2',content: 'Rectangle2'}],
    }
];

let connectors: ConnectorModel[]= [
    {
      id: 'connector1',
      sourceID: 'node1',
      targetID: 'node2',
    },
  ];

const contextMenuSettings = {
    //Enables the context menu
    show: true,
    items: [
        {
          text: 'Change fill',
          id: 'applyFill',
          target: '.e-diagramcontent',
          iconCss: 'e-icons e-paint-bucket',
        },
        {
          text: 'Change stroke',
          id: 'applyStroke',
          target: '.e-diagramcontent',
          iconCss: 'e-icons e-edit',
        },
        {
          text: 'Select All',
          id: 'selectAll',
          target: '.e-diagramcontent',
        },
      ],
    // Hides the default context menu items
    showCustomMenuOnly: true,
};

//Initializes the Diagram component
function App() {
    return (<DiagramComponent id="diagram_contextmenu" ref={(diagram) => (diagramInstance = diagram)} width={'650px'} height={'350px'} nodes={node} connectors={connectors}
        contextMenuSettings={contextMenuSettings}  

        contextMenuOpen= {(args: DiagramBeforeMenuOpenEventArgs) =>{

            let hiddenItems = [];
            let selectedNode = diagramInstance.selectedItems.nodes[0];
            let selectedConnector = diagramInstance.selectedItems.connectors[0];
            if (selectedNode || selectedConnector) {
                hiddenItems.push('selectAll');
            } else {
                hiddenItems = ['applyFill', 'applyStroke'];
            }
            args.hiddenItems = hiddenItems;

        }}

        contextMenuClick= {(args: MenuEventArgs) => {
            let selectedNode = diagramInstance.selectedItems.nodes[0];
            let selectedConnector = diagramInstance.selectedItems.connectors[0];
            if (selectedNode || selectedConnector) {
              if (selectedNode) {
                if (args.item.id === 'applyFill') {
                  selectedNode.style.fill =
                    selectedNode.style.fill === '#6BA5D7' ? 'green' : '#6BA5D7';
                } else if (args.item.id === 'applyStroke') {
                  selectedNode.style.strokeColor =
                    selectedNode.style.strokeColor === 'black' ? 'yellow' : 'black';
                }
              }
              if (selectedConnector) {
                if (args.item.id === 'applyFill') {
                  selectedConnector.targetDecorator.style.fill =
                    selectedConnector.targetDecorator.style.fill === 'yellow'
                      ? 'black'
                      : 'yellow';
                }
                selectedConnector.style.strokeColor =
                  selectedConnector.style.strokeColor === 'black'
                    ? 'yellow'
                    : 'black';
              }
            } else {
                diagramInstance.selectAll();
            }
        }}>
    <Inject services={[DiagramContextMenu]}/>
    </DiagramComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Context Menu with URL

Use theurl property of menu items to set website URLs that open when clicked.

The following code example shows the context menu with url for three websites.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, DiagramContextMenu, Inject } from "@syncfusion/ej2-react-diagrams";

let diagramInstance;

let node = [{
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{id: 'label1',content: 'Rectangle1'}],
    }, {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{id: 'label2',content: 'Rectangle2'}],
    }
];

//Initializes the Diagram component
function App() {
    return (<DiagramComponent id="diagram_contextmenu" ref={(diagram) => (diagramInstance = diagram)} width={'650px'} height={'350px'} nodes={node} 
        contextMenuSettings={{
            //Enables the context menu
            show: true,
            items: [
                {
                  text: 'Google.com',
                  id: 'google',
                  target: '.e-diagramcontent',
                  url: 'https://www.google.co.in/',
                },
                {
                  text: 'w3schools.com',
                  id: 'W3Schools',
                  target: '.e-diagramcontent',
                  url: 'https://www.w3schools.com/',
                },
                {
                  text: 'stackoverflow.com',
                  id: 'stackoverflow',
                  target: '.e-diagramcontent',
                  url: 'https://stackoverflow.com/',
                },
              ],
            // Hides the default context menu items.
            showCustomMenuOnly: true,
        }}>
    <Inject services={[DiagramContextMenu]}/>
    </DiagramComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Template Support for Context Menu

The Diagram component provides template support for context menu customization. Customize menu item templates before rendering using the contextMenuBeforeItemRender event, which triggers while rendering each menu item.

The following example renders menu items with shortcut key codes for specific actions. Key codes for cut, copy, and paste actions display in the right corner of menu items by adding a span element in the contextMenuBeforeItemRender event:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { createElement } from '@syncfusion/ej2-base';
import { DiagramComponent, Inject, DiagramContextMenu } from "@syncfusion/ej2-react-diagrams";

let diagramInstance;

//Initializes the nodes
let node = [{
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{id: 'label1', content: 'Rectangle1' }]
    }, {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{id: 'label2',content: 'Rectangle2'}]
    }];
  
const contextMenuSettings = {
    //Enables the context menu
    show: true,
    items: [
        {
          text: 'Cut',
          id: 'Cut',
          target: '.e-diagramcontent',
          iconCss: 'e-cut e-icons',
        },
        {
          text: 'Copy',
          id: 'Copy',
          target: '.e-diagramcontent',
          iconCss: 'e-icons e-copy',
        },
        {
          text: 'Paste',
          id: 'Paste',
          target: '.e-diagramcontent',
          iconCss: 'e-icons e-paste',
        },
      ],
    // Hides the default context menu items
    showCustomMenuOnly: true,
};

//Initializes the Diagram component
function App() {
    return (<DiagramComponent id="diagram_contextmenu" ref={(diagram) => (diagramInstance = diagram)} width={'650px'} height={'350px'} nodes={node} 
    contextMenuSettings={contextMenuSettings}  
    contextMenuBeforeItemRender= {(args) =>{
        // To render template in li.
        let shortCutSpan = createElement('span');
        let text = args.item.text;
        let shortCutText =
          text === 'Cut' ? 'Ctrl + X' : text === 'Copy' ? 'Ctrl + C' : 'Ctrl + V';
        shortCutSpan.textContent = shortCutText;
        //Added CSS styles for the class shortcut to customize its position and appearance
        shortCutSpan.setAttribute('class', 'shortcut');
        args.element.appendChild(shortCutSpan);
    }}

    contextMenuClick={(args) =>{
        let selectedNode = diagramInstance.selectedItems.nodes[0];
        if (selectedNode) {
          if (args.item.text === 'Cut') {
            diagramInstance.cut();
           } else if (args.item.text === 'Copy') {
            diagramInstance.copy();
           }
        }
        if (args.item.text === 'Paste') {
            diagramInstance.paste();
        }
    }}>

    <Inject services={[DiagramContextMenu]}/>
    </DiagramComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { createElement } from '@syncfusion/ej2-base';
import { DiagramComponent, Inject, DiagramContextMenu, NodeModel } from "@syncfusion/ej2-react-diagrams";
import { MenuEventArgs } from '@syncfusion/ej2-navigations';

let diagramInstance:DiagramComponent ;

//Initializes the nodes
let node: NodeModel[] = [{
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{id: 'label1', content: 'Rectangle1' }]
    }, {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{id: 'label2',content: 'Rectangle2'}]
    }];

const contextMenuSettings = {
    //Enables the context menu
    show: true,
    items: [
        {
          text: 'Cut',
          id: 'Cut',
          target: '.e-diagramcontent',
          iconCss: 'e-cut e-icons',
        },
        {
          text: 'Copy',
          id: 'Copy',
          target: '.e-diagramcontent',
          iconCss: 'e-icons e-copy',
        },
        {
          text: 'Paste',
          id: 'Paste',
          target: '.e-diagramcontent',
          iconCss: 'e-icons e-paste',
        },
      ],
    // Hides the default context menu items
    showCustomMenuOnly: true,
};
    
//Initializes the Diagram component
function App() {
    return (<DiagramComponent id="diagram_contextmenu" ref={(diagram) => (diagramInstance = diagram)} width={'650px'} height={'350px'} nodes={node} 
    contextMenuSettings={contextMenuSettings}  
    contextMenuBeforeItemRender= {(args: MenuEventArgs) =>{
        // To render template in li.
        let shortCutSpan = createElement('span');
        let text = args.item.text;
        let shortCutText =
          text === 'Cut' ? 'Ctrl + X' : text === 'Copy' ? 'Ctrl + C' : 'Ctrl + V';
        shortCutSpan.textContent = shortCutText;
        //Added CSS styles for the class shortcut to customize its position and appearance
        shortCutSpan.setAttribute('class', 'shortcut');
        args.element.appendChild(shortCutSpan);
    }}

    contextMenuClick={(args: MenuEventArgs) =>{
        let selectedNode = diagramInstance.selectedItems.nodes[0];
        if (selectedNode) {
          if (args.item.text === 'Cut') {
            diagramInstance.cut();
           } else if (args.item.text === 'Copy') {
            diagramInstance.copy();
           }
        }
        if (args.item.text === 'Paste') {
            diagramInstance.paste();
        }
    }}>

    <Inject services={[DiagramContextMenu]}/>
    </DiagramComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Context Menu Events

Event Description
contextMenuBeforeItemRender Triggers while initializing each menu item.
contextMenuOpen Triggers upon right-click before opening the context menu.
contextMenuClick Triggers when a menu item is clicked.

The following example shows how to get these events.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, DiagramContextMenu } from "@syncfusion/ej2-react-diagrams";
let diagramInstance;

let connector = [{
        id: 'connector1',
        sourceID: 'node1',
        targetID: 'node2',
  
}];

let node = [{
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ id: 'label1', content: 'Rectangle1' }]
    }, {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{id: 'label2', content: 'Rectangle2'}]
}];

const contextMenuSettings = {
        //Enables the context menu
        show: true,
        items: [
            {
              text: 'menu item 1',
              id: 'item1',
            },
            {
              text: 'menu item 2',
              id: 'item2',
            },
          ],
        // Hides the default context menu items
        showCustomMenuOnly: true,
};

//Initializes the Diagram component
function App() {
    return (<DiagramComponent id="diagram_contextmenu" ref={(diagram) => (diagramInstance = diagram)} width={'650px'} height={'350px'} nodes={node} connectors={connector} contextMenuSettings={contextMenuSettings} 
    contextMenuBeforeItemRender={(args) => {
        //Triggers when the menu is openned
        console.log('context menu before item render');
    }}
    contextMenuOpen={(args) => {
        //Triggers when the menu is openned
        console.log('context menu openned');
    }}
    contextMenuClick={(args) => {
       //Triggers when the item is clicked
       console.log('context menu clicked');
 
    }}>
    <Inject services={[DiagramContextMenu]}/>
    </DiagramComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, DiagramContextMenu, NodeModel, ConnectorModel, DiagramBeforeMenuOpenEventArgs} from "@syncfusion/ej2-react-diagrams";
import { MenuEventArgs } from '@syncfusion/ej2-navigations';

let diagramInstance: DiagramComponent;

let connector: ConnectorModel[] = [{
        id: 'connector1',
        sourceID: 'node1',
        targetID: 'node2',
  
}];

let node: NodeModel[] = [{
        id: 'node1',
        width: 100,
        height: 100,
        offsetX: 100,
        offsetY: 100,
        annotations: [{ id: 'label1', content: 'Rectangle1' }]
    }, {
        id: 'node2',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 100,
        annotations: [{id: 'label2', content: 'Rectangle2'}]
}];

const contextMenuSettings = {
        //Enables the context menu
        show: true,
        items: [
            {
              text: 'menu item 1',
              id: 'item1',
            },
            {
              text: 'menu item 2',
              id: 'item2',
            },
          ],
        // Hides the default context menu items
        showCustomMenuOnly: true,
};

//Initializes the Diagram component
function App() {
    return (<DiagramComponent id="diagram_contextmenu" ref={(diagram) => (diagramInstance = diagram)} width={'650px'} height={'350px'} nodes={node} connectors={connector} contextMenuSettings={contextMenuSettings} 
    contextMenuBeforeItemRender={(args: MenuEventArgs) => {
        //Triggers when the menu is openned
        console.log('context menu before item render');
    }}
    contextMenuOpen={(args: DiagramBeforeMenuOpenEventArgs) => {
        //Triggers when the menu is openned
        console.log('context menu openned');
    }}
    contextMenuClick={(args: MenuEventArgs) => {
       //Triggers when the item is clicked
       console.log('context menu clicked');
 
    }}>
    <Inject services={[DiagramContextMenu]}/>
    </DiagramComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

## See Also

Context menu in Vue Diagram component

4 Jul 202624 minutes to read

In a graphical user interface (GUI), a context menu is a type of menu that appears when you perform a right-click operation. It offers users a set of actions relevant to the current context. In diagrams, context menus can be customized extensively. The Vue Diagram control provides built-in context menu items while also allowing users to define custom menu items through the contextMenuSettings property. This flexibility enables tailoring menus to specific application needs, including creating nested levels of menu items for more intricate user interactions.To ensure the context menu is rendered correctly, make sure to include the necessary CSS references from the Syncfusion® ej2-navigations package. This can be achieved by adding the following line in the <style> section of your src/App.vue file.

@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";

NOTE

If you want to use contextMenu in diagram, you need to inject DiagramContextMenu Module in the diagram.

Default context menu

Diagram provides some default context menu items to ease the execution of some frequently used commands. The show property helps you to enable/disable the context menu. The following code illustrates how to enable the default context menu items.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :connectors='connectors'
            :contextMenuSettings='contextMenuSettings'></ejs-diagram>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { DiagramComponent as EjsDiagram, DiagramContextMenu } from '@syncfusion/ej2-vue-diagrams';

let nodes = [{
    id: 'node1',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [{
        id: 'label1',
        content: 'Rectangle1',
    }]
},
{
    id: 'node2',
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
    annotations: [{
        id: 'label2',
        content: 'Rectangle2',
    }]
}];

let connectors = [{
    id: 'connector1',
    sourceID: 'node1',
    targetID: 'node2',
    type: 'Straight',
}]

const width = "100%";
const height = "350px";
const contextMenuSettings = {
    //Enables the context menu
    show: true,
}

provide('diagram', [DiagramContextMenu]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :connectors='connectors'
            :contextMenuSettings='contextMenuSettings'></ejs-diagram>
    </div>
</template>
<script>
import { DiagramComponent, DiagramContextMenu } from '@syncfusion/ej2-vue-diagrams';

let nodes = [{
    id: 'node1',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [{
        id: 'label1',
        content: 'Rectangle1',
    }]
},
{
    id: 'node2',
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
    annotations: [{
        id: 'label2',
        content: 'Rectangle2',
    }]
}];

let connectors = [{
    id: 'connector1',
    sourceID: 'node1',
    targetID: 'node2',
    type: 'Straight',
}];

export default {
    name: "App",
    components: {
        "ejs-diagram": DiagramComponent
    },
    data() {
        return {
            width: "100%",
            height: "350px",
            nodes: nodes,
            connectors: connectors,
            contextMenuSettings: {
                //Enables the context menu
                show: true,

            }
        }
    },
    provide: {
        diagram: [DiagramContextMenu]
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Custom context menu

Context menus can be customized for individual nodes by defining specific menu items beyond the default options. To add additional context menu items, you need to define and incorporate them into the items property of the context menu.

Each custom item can be defined with specific text and ID using the text and id properties, respectively. Additionally, you can enhance visual cues by associating icons through the iconCss for enabling the use of font icons. The target property specifies where each menu item should appear, and separators can be included using the separator property to visually group menu items. This flexibility allows for a tailored user interface that meets specific application needs efficiently. Nested menu items are defined within the items property of a parent menu item.

To Display custom menu alone

To display the custom context menu items alone, set the showCustomMenuOnly property to true.

Context menu click

Upon clicking custom menu items, actions are handled using the contextMenuClick event in the diagram. This event allows you to define actions based on which menu item is clicked. For instance, in the example below, the cloning of nodes and the change of fill color for nodes and annotations are efficiently managed and implemented through this event.

<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagram" :width='width' :height='height' :nodes='nodes' 
            :contextMenuSettings='contextMenuSettings' :contextMenuClick="contextMenuClick"></ejs-diagram>
    </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { DiagramComponent as EjsDiagram, DiagramContextMenu } from '@syncfusion/ej2-vue-diagrams';

const diagram = ref(null);
const nodes = [{
    id: 'node1',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [{
        id: 'label1',
        content: 'Rectangle1',
    }]
},
{
    id: 'node2',
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
    annotations: [{
        id: 'label2',
        content: 'Rectangle2',
    }]
}
];


const width = "100%";
const height = "350px";
const contextMenuSettings= {
        //Enables the context menu
        show: true,
        items: [
          {
            // Text to be displayed
            text: "Fill",
            items: [
              { id: "red", text: "Red" },
              { id: "yellow", text: "Yellow" },
              { id: "green", text: "Green" },
              { id: "blue", text: "Blue" },
            ],
            //Sets the id for the item
            id: "fill",
            target: ".e-elementcontent",
            // Sets the css icons for the item
            iconCss: "e-icons e-paint-bucket",
          },
          {
            text: "Annotation color",
            id: "annotationColor",
            items: [
              { id: "pink", text: "Pink" },
              { id: "orange", text: "Orange" },
              { id: "violet", text: "Violet" },
              { id: "brown", text: "Brown" },
            ],
            target: ".e-elementcontent",
            iconCss: "e-icons e-font-color",
          },
          {
            text: "Clone",
            id: "clone",
            target: ".e-elementcontent",
            iconCss: "e-icons e-copy",
          },
        ],
        // Hides the default context menu items
        showCustomMenuOnly: true,
};

const contextMenuClick = (args) => {
    var diagram = diagram.value.ej2Instances;
    let selectedNode = diagram.selectedItems.nodes[0];
    if (
        selectedNode &&
        args.item.id !== "fill" &&
        args.item.id !== "annotationColor"
    ) {
        if (
        args.item.text === "Red" ||
        args.item.text === "Blue" ||
        args.item.text === "Yellow" ||
        args.item.text === "Green"
        ) {
        selectedNode.style.fill = args.item.text;
        diagram.dataBind();
        } else if (
        args.item.text === "Pink" ||
        args.item.text === "Violet" ||
        args.item.text === "Orange" ||
        args.item.text === "Brown"
        ) {
        selectedNode.annotations[0].style.fill = args.item.text;
        diagram.dataBind();
        } else {
        diagram.copy();
        diagram.paste();
        }
    }
}

provide('diagram', [DiagramContextMenu]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
      :contextMenuSettings="contextMenuSettings"
      :contextMenuClick="contextMenuClick"
    ></ejs-diagram>
  </div>
</template>
<script>
import {DiagramComponent,DiagramContextMenu} from "@syncfusion/ej2-vue-diagrams";

let nodes = [
  {
    id: "node1",
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [
      {
        id: "label1",
        content: "Rectangle1",
      },
    ],
  },
  {
    id: "node2",
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
    annotations: [
      {
        id: "label2",
        content: "Rectangle2",
      },
    ],
  },
];


export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      width: "100%",
      height: "350px",
      nodes: nodes,
      contextMenuSettings: {
        //Enables the context menu
        show: true,
        items: [
          {
            // Text to be displayed
            text: "Fill",
            items: [
              { id: "red", text: "Red" },
              { id: "yellow", text: "Yellow" },
              { id: "green", text: "Green" },
              { id: "blue", text: "Blue" },
            ],
            //Sets the id for the item
            id: "fill",
            target: ".e-elementcontent",
            // Sets the css icons for the item
            iconCss: "e-icons e-paint-bucket",
          },
          {
            text: "Annotation color",
            id: "annotationColor",
            items: [
              { id: "pink", text: "Pink" },
              { id: "orange", text: "Orange" },
              { id: "violet", text: "Violet" },
              { id: "brown", text: "Brown" },
            ],
            target: ".e-elementcontent",
            iconCss: "e-icons e-font-color",
          },
          {
            text: "Clone",
            id: "clone",
            target: ".e-elementcontent",
            iconCss: "e-icons e-copy",
          },
        ],
        // Hides the default context menu items
        showCustomMenuOnly: true,
      },
      contextMenuClick: (args) => {
        var diagram = this.$refs.diagram.ej2Instances;
        let selectedNode = diagram.selectedItems.nodes[0];
        if (
          selectedNode &&
          args.item.id !== "fill" &&
          args.item.id !== "annotationColor"
        ) {
          if (
            args.item.text === "Red" ||
            args.item.text === "Blue" ||
            args.item.text === "Yellow" ||
            args.item.text === "Green"
          ) {
            selectedNode.style.fill = args.item.text;
            diagram.dataBind();
          } else if (
            args.item.text === "Pink" ||
            args.item.text === "Violet" ||
            args.item.text === "Orange" ||
            args.item.text === "Brown"
          ) {
            selectedNode.annotations[0].style.fill = args.item.text;
            diagram.dataBind();
          } else {
            diagram.copy();
            diagram.paste();
          }
        }
      },
    };
  },
  provide: {
    diagram: [DiagramContextMenu],
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Context menu open

In certain situations, you may want to hide specific menu items based on the selected elements in the diagram. This can be achieved using the contextMenuOpen event. When the context menu is opened via right-click, the contextMenuOpen event is triggered. Within this event, you can create an array of menu items to hide for the selected element and pass it to the hiddenItems property of the contextMenuOpen event argument. The following example demonstrates how to display different custom menu items for nodes, connectors, and the diagram based on the selection.

<template>
    <div id="app">
        <ejs-diagram id="diagram" ref="diagram" :width='width' :height='height' :nodes='nodes' :connectors='connectors'
            :contextMenuSettings='contextMenuSettings' :contextMenuOpen="contextMenuOpen"
            :contextMenuClick="contextMenuClick"></ejs-diagram>
    </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { DiagramComponent as EjsDiagram, DiagramContextMenu } from '@syncfusion/ej2-vue-diagrams';

const diagram = ref(null);
const nodes = [{
    id: 'node1',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [{
        id: 'label1',
        content: 'Rectangle1',
    }]
},
{
    id: 'node2',
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
    annotations: [{
        id: 'label2',
        content: 'Rectangle2',
    }]
}
];
const connectors = [{
    id: 'connector1',
    sourceID: 'node1',
    targetID: 'node2',
    type: 'Straight',
}]

const width = "100%";
const height = "350px";
const contextMenuSettings = {
    show: true,
    items: [
        {
        text: "Change fill",
        id: "applyFill",
        target: ".e-diagramcontent",
        iconCss: "e-icons e-paint-bucket",
        },
        {
        text: "Change stroke",
        id: "applyStroke",
        target: ".e-diagramcontent",
        iconCss: "e-icons e-edit",
        },
        {
        text: "Select All",
        id: "selectAll",
        target: ".e-diagramcontent",
        },
    ],
    showCustomMenuOnly: true,
};
const contextMenuOpen = (args) => {
    var diagram = diagram.value.ej2Instances;
    let hiddenItems = [];
    let selectedNode = diagram.selectedItems.nodes[0];
    let selectedConnector = diagram.selectedItems.connectors[0];
    if (selectedNode || selectedConnector) {
        hiddenItems.push("selectAll");
    } else {
        hiddenItems = ["applyFill", "applyStroke"];
    }
    args.hiddenItems = hiddenItems;
}
const contextMenuClick = (args) => {
    var diagram = diagram.value.ej2Instances;
    let selectedNode = diagram.selectedItems.nodes[0];
    let selectedConnector = diagram.selectedItems.connectors[0];
    if (selectedNode || selectedConnector) {
        if (selectedNode) {
        if (args.item.id === "applyFill") {
            selectedNode.style.fill =
            selectedNode.style.fill === "#6BA5D7" ? "green" : "#6BA5D7";
        } else if (args.item.id === "applyStroke") {
            selectedNode.style.strokeColor =
            selectedNode.style.strokeColor === "black" ? "yellow" : "black";
        }
        }
        if (selectedConnector) {
        if (args.item.id === "applyFill") {
            selectedConnector.targetDecorator.style.fill =
            selectedConnector.targetDecorator.style.fill === "yellow"? "black": "yellow";
        }
        selectedConnector.style.strokeColor = selectedConnector.style.strokeColor === "black"? "yellow": "black";
        }
    } else {
        diagram.selectAll();
    }
}

provide('diagram', [DiagramContextMenu]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
      :connectors="connectors"
      :contextMenuSettings="contextMenuSettings"
      :contextMenuOpen="contextMenuOpen"
      :contextMenuClick="contextMenuClick"
    ></ejs-diagram>
  </div>
</template>
<script>
import {DiagramComponent,DiagramContextMenu} from "@syncfusion/ej2-vue-diagrams";

let nodes = [
  {
    id: "node1",
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [
      {
        id: "label1",
        content: "Rectangle1",
      },
    ],
  },
  {
    id: "node2",
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
    annotations: [
      {
        id: "label2",
        content: "Rectangle2",
      },
    ],
  },
];

let connectors = [
  {
    id: "connector1",
    sourceID: "node1",
    targetID: "node2",
    type: "Straight",
  },
];

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      width: "100%",
      height: "350px",
      nodes: nodes,
      connectors: connectors,
      contextMenuSettings: {
        show: true,
        items: [
          {
            text: "Change fill",
            id: "applyFill",
            target: ".e-diagramcontent",
            iconCss: "e-icons e-paint-bucket",
          },
          {
            text: "Change stroke",
            id: "applyStroke",
            target: ".e-diagramcontent",
            iconCss: "e-icons e-edit",
          },
          {
            text: "Select All",
            id: "selectAll",
            target: ".e-diagramcontent",
          },
        ],
        showCustomMenuOnly: true,
      },
      contextMenuOpen: (args) => {
        var diagram = this.$refs.diagram.ej2Instances;
        let hiddenItems = [];
        let selectedNode = diagram.selectedItems.nodes[0];
        let selectedConnector = diagram.selectedItems.connectors[0];
        if (selectedNode || selectedConnector) {
          hiddenItems.push("selectAll");
        } else {
          hiddenItems = ["applyFill", "applyStroke"];
        }
        args.hiddenItems = hiddenItems;
      },
      contextMenuClick: (args) => {
        var diagram = this.$refs.diagram.ej2Instances;
        let selectedNode = diagram.selectedItems.nodes[0];
        let selectedConnector = diagram.selectedItems.connectors[0];
        if (selectedNode || selectedConnector) {
          if (selectedNode) {
            if (args.item.id === "applyFill") {
              selectedNode.style.fill =
                selectedNode.style.fill === "#6BA5D7" ? "green" : "#6BA5D7";
            } else if (args.item.id === "applyStroke") {
              selectedNode.style.strokeColor =
                selectedNode.style.strokeColor === "black" ? "yellow" : "black";
            }
          }
          if (selectedConnector) {
            if (args.item.id === "applyFill") {
              selectedConnector.targetDecorator.style.fill =
                selectedConnector.targetDecorator.style.fill === "yellow"
                  ? "black"
                  : "yellow";
            }
            selectedConnector.style.strokeColor =
              selectedConnector.style.strokeColor === "black"
                ? "yellow"
                : "black";
          }
        } else {
          diagram.selectAll();
        }
      },
    };
  },
  provide: {
    diagram: [DiagramContextMenu],
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Context menu with Url

url property of the menu item is used to set the url of any website which will be opened upon clicking on them. The following example shows the context menu with url for three websites.

<template>
  <div id="app">
    <ejs-diagram id="diagram" ref="diagram" :width="width" :height="height" :nodes="nodes"
      :contextMenuSettings="contextMenuSettings" :contextMenuBeforeItemRender="itemBeforeRender">
    </ejs-diagram>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { DiagramComponent as EjsDiagram, DiagramContextMenu } from '@syncfusion/ej2-vue-diagrams';

const width = "100%";
const height = "350px";

let nodes = [
  {
    id: "node1",
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [
      {
        id: "label1",
        content: "Rectangle1",
      },
    ],
  },
  {
    id: "node2",
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
    annotations: [
      {
        id: "label2",
        content: "Rectangle2",
      },
    ],
  },
];

const contextMenuSettings = {
  show: true,
  items: [
    {
      text: "Google.com",
      id: "google",
      target: ".e-diagramcontent",
      url: "https://www.google.co.in/",
    },
    {
      text: "w3schools.com",
      id: "W3Schools",
      target: ".e-diagramcontent",
      url: "https://www.w3schools.com/",
    },
    {
      text: "stackoverflow.com",
      id: "stackoverflow",
      target: ".e-diagramcontent",
      url: "https://stackoverflow.com/",
    },
  ],
  showCustomMenuOnly: true,
};

const itemBeforeRender = (args) => {
  args.element.getElementsByTagName('a')[0].setAttribute('target', '_blank');
}

provide('diagram', [DiagramContextMenu]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-icons/styles/tailwind3.css';
</style>
<template>
  <div id="app">
    <ejs-diagram id="diagram" ref="diagram" :width="width" :height="height" :nodes="nodes"
      :contextMenuSettings="contextMenuSettings" :contextMenuBeforeItemRender="contextMenuBeforeItemRender">
    </ejs-diagram>
  </div>
</template>
<script>
import {
  DiagramComponent,
  DiagramContextMenu,
} from "@syncfusion/ej2-vue-diagrams";

let nodes = [
  {
    id: "node1",
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [
      {
        id: "label1",
        content: "Rectangle1",
      },
    ],
  },
  {
    id: "node2",
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
    annotations: [
      {
        id: "label2",
        content: "Rectangle2",
      },
    ],
  },
];

const itemBeforeRender = (args) => {
  args.element.getElementsByTagName('a')[0].setAttribute('target', '_blank');
}

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      width: "100%",
      height: "350px",
      nodes: nodes,
      contextMenuSettings: {
        show: true,
        items: [
          {
            text: "Google.com",
            id: "google",
            target: ".e-diagramcontent",
            url: "https://www.google.co.in/",
          },
          {
            text: "w3schools.com",
            id: "W3Schools",
            target: ".e-diagramcontent",
            url: "https://www.w3schools.com/",
          },
          {
            text: "stackoverflow.com",
            id: "stackoverflow",
            target: ".e-diagramcontent",
            url: "https://stackoverflow.com/",
          },
        ],
        showCustomMenuOnly: true,
      },
      contextMenuBeforeItemRender: itemBeforeRender
    };
  },
  provide: {
    diagram: [DiagramContextMenu],
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-icons/styles/tailwind3.css';
</style>

NOTE

To open the links in new tab, set target attribute with the value _blank in the the contextMenuBeforeItemRender event.

Template Support for Context menu

Diagram provides template support for the context menu. The template for the context menu items can be customized before rendering by using the contextMenuBeforeItemRender event, which triggers while rendering each menu item.

In the following example, menu items are rendered with shortcut key codes for specific actions in the context menu using a template. The key codes for cut, copy, and paste actions are displayed at the right corner of the menu items by adding a span element in the contextMenuBeforeItemRender event.

<template>
    <div id="app">
        <ejs-diagram id="diagram"  ref="diagram" :width='width' :height='height' :nodes='nodes'
            :contextMenuSettings='contextMenuSettings'  :contextMenuClick='contextMenuClick'
      :contextMenuBeforeItemRender='contextMenuBeforeItemRender'></ejs-diagram>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { DiagramComponent as EjsDiagram, DiagramContextMenu } from '@syncfusion/ej2-vue-diagrams';
import { createElement } from "@syncfusion/ej2-base";

const nodes = [{
    id: 'node1',
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [{
        id: 'label1',
        content: 'Rectangle1',
    }]
},
{
    id: 'node2',
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
    annotations: [{
        id: 'label2',
        content: 'Rectangle2',
    }]
}
];


const width = "100%";
const height = "350px";
const contextMenuSettings = {
     show: true,
        items: [
          {
            text: "Cut",
            id: "Cut",
            target: ".e-diagramcontent",
            iconCss: "e-cut e-icons",
          },
          {
            text: "Copy",
            id: "Copy",
            target: ".e-diagramcontent",
            iconCss: "e-icons e-copy",
          },
          {
            text: "Paste",
            id: "Paste",
            target: ".e-diagramcontent",
            iconCss: "e-icons e-paste",
          },
        ],
        showCustomMenuOnly: true,
};
const contextMenuBeforeItemRender = (args) => {
        // To render template in li.
        let shortCutSpan = createElement("span");
        let text = args.item.text;
        let shortCutText =
          text === "Cut"
            ? " Ctrl + X"
            : text === "Copy"
            ? " Ctrl + C"
            : " Ctrl + V";
        shortCutSpan.textContent = shortCutText;
        shortCutSpan.setAttribute("class", "shortcut");
        args.element.appendChild(shortCutSpan);
};
const contextMenuClick = (args) => {
        var diagram = diagram.value.ej2Instances;
        let selectedNode = diagram.selectedItems.nodes[0];
        if (selectedNode) {
          if (args.item.text === "Cut") {
            diagram.cut();
          } else if (args.item.text === "Copy") {
            diagram.copy();
          }
        }
        if (args.item.text === "Paste") {
          diagram.paste();
        }
};

provide('diagram', [DiagramContextMenu]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
      :contextMenuSettings="contextMenuSettings"
      :contextMenuClick="contextMenuClick"
      :contextMenuBeforeItemRender="contextMenuBeforeItemRender"
    ></ejs-diagram>
  </div>
</template>
<script>
import {DiagramComponent, DiagramContextMenu,} from "@syncfusion/ej2-vue-diagrams";
import { createElement } from "@syncfusion/ej2-base";

let nodes = [
  {
    id: "node1",
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [
      {
        id: "label1",
        content: "Rectangle1",
      },
    ],
  },
  {
    id: "node2",
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
    annotations: [
      {
        id: "label2",
        content: "Rectangle2",
      },
    ],
  },
];

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      width: "100%",
      height: "350px",
      nodes: nodes,
      contextMenuSettings: {
        show: true,
        items: [
          {
            text: "Cut",
            id: "Cut",
            target: ".e-diagramcontent",
            iconCss: "e-cut e-icons",
          },
          {
            text: "Copy",
            id: "Copy",
            target: ".e-diagramcontent",
            iconCss: "e-icons e-copy",
          },
          {
            text: "Paste",
            id: "Paste",
            target: ".e-diagramcontent",
            iconCss: "e-icons e-paste",
          },
        ],
        showCustomMenuOnly: true,
      },
      contextMenuBeforeItemRender: (args) => {
        // To render template in li.
        let shortCutSpan = createElement("span");
        let text = args.item.text;
        let shortCutText =
          text === "Cut"
            ? " Ctrl + X"
            : text === "Copy"
            ? " Ctrl + C"
            : " Ctrl + V";
        shortCutSpan.textContent = shortCutText;
        shortCutSpan.setAttribute("class", "shortcut");
        args.element.appendChild(shortCutSpan);
      },
      contextMenuClick: (args) => {
        var diagram = this.$refs.diagram.ej2Instances;
        let selectedNode = diagram.selectedItems.nodes[0];
        if (selectedNode) {
          if (args.item.text === "Cut") {
            diagram.cut();
          } else if (args.item.text === "Copy") {
            diagram.copy();
          }
        }
        if (args.item.text === "Paste") {
          diagram.paste();
        }
      },
    };
  },
  provide: {
    diagram: [DiagramContextMenu],
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Context menu events

Event Description
contextMenuBeforeItemRender Triggers while initializing each menu item.
contextMenuOpen Triggers upon right-click before opening the context menu.
contextMenuClick Triggers when a menu item is clicked.

The following example shows how to get these events.

<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
      :connectors="connectors"
      :contextMenuSettings="contextMenuSettings"
      :contextMenuOpen="contextMenuOpen"
      :contextMenuBeforeItemRender="contextMenuBeforeItemRender"
      :contextMenuClick="contextMenuClick"
    ></ejs-diagram>
  </div>
</template>
<script setup>
import { provide } from "vue";
import {DiagramComponent as EjsDiagram,DiagramContextMenu,Diagram} from "@syncfusion/ej2-vue-diagrams";

let nodes = [
  {
    id: "node1",
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [
      {
        id: "label1",
        content: "Rectangle1",
      },
    ],
  },
  {
    id: "node2",
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
    annotations: [
      {
        id: "label2",
        content: "Rectangle2",
      },
    ],
  },
];
let connectors = [
  {
    id: "connector1",
    sourceID: "node1",
    targetID: "node2",
    type: "Straight",
  },
];

const width = "100%";
const height = "350px";
const contextMenuSettings = {
  show: true,
  items: [
          {
            text: "menu item 1",
            id: "item1",
          },
          {
            text: "menu item 2",
            id: "item2",
          },
        ],
        showCustomMenuOnly: true,
};
const contextMenuBeforeItemRender = (args) => {
  //Triggers for each menu item
  console.log("context menu before item render");
};
const contextMenuOpen = (args) => {
  //Triggers when the menu is openned
  console.log("context menu openned");
};
const contextMenuClick = (args) => {
  //Triggers when the item is clicked
  console.log("context menu clicked");
};

provide("diagram", [DiagramContextMenu]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
      :connectors="connectors"
      :contextMenuSettings="contextMenuSettings"
      :contextMenuOpen="contextMenuOpen"
      :contextMenuBeforeItemRender="contextMenuBeforeItemRender"
      :contextMenuClick="contextMenuClick"
    ></ejs-diagram>
  </div>
</template>
<script>
import {DiagramComponent,DiagramContextMenu,Diagram} from "@syncfusion/ej2-vue-diagrams";

let nodes = [
  {
    id: "node1",
    width: 100,
    height: 100,
    offsetX: 100,
    offsetY: 100,
    annotations: [
      {
        id: "label1",
        content: "Rectangle1",
      },
    ],
  },
  {
    id: "node2",
    width: 100,
    height: 100,
    offsetX: 300,
    offsetY: 100,
    annotations: [
      {
        id: "label2",
        content: "Rectangle2",
      },
    ],
  },
];

let connectors = [
  {
    id: "connector1",
    sourceID: "node1",
    targetID: "node2",
    type: "Straight",
  },
];

export default {
  name: "App",
  components: {
    "ejs-diagram": DiagramComponent,
  },
  data() {
    return {
      width: "100%",
      height: "350px",
      nodes: nodes,
      connectors: connectors,
      contextMenuSettings: {
        show: true,
        items: [
          {
            text: "menu item 1",
            id: "item1",
          },
          {
            text: "menu item 2",
            id: "item2",
          },
        ],
        showCustomMenuOnly: true,
      },
      contextMenuBeforeItemRender:function (args) {
        //Triggers for each menu item
        console.log("context menu before item render");
      },
      contextMenuOpen: function (args) {
        //Triggers when the menu is openned
        console.log("context menu openned");
      },
      contextMenuClick: function (args) {
        //Triggers when the item is clicked
        console.log("context menu clicked");
      },
    };
  },
  provide: {
    diagram: [DiagramContextMenu],
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

See Also